from subprocess import *
import shutil
import os

mayaBinaries = 'C:/Program Files/Autodesk/Maya2008/bin/'
mayaScene = 'C:/Buddha/scenes/InitialScene11.mb'

def Batch( start, end, inc ):
	camList = []
	while start < end:
		camList.append( Camera( start, start+inc-1 ) )
		start += inc 
	
	for cam in camList:
		cmd = mayaBinaries+'render'
		cmd += ' -cam '+cam.name+' -s '+str(cam.s)+' -e '+str(cam.e)+' -im '+cam.im 
		cmd += ' '+mayaScene
		print "Running", cmd
		pipe = Popen(cmd)
		pipe.wait()

class Camera():
	def __init__( self, s, e ):
		self.name = 'cam_rendCam'
		self.s = s
		self.e = e
		self.im = self.name+'Out'

start = 0
end = 4000
inc = 500
Batch( start, end, inc )
