from subprocess import *
import shutil
import os

def getUTGamePath():
	return 'C:\Users\denrei\Documents\My Games\Unreal Tournament 3\UTGame'
def getUTBinariesPath():
	return 'C:\\Unreal Tournament 3\\Binaries'
def getMap():
	return "UTFrontEndCoda.ut3"
def getLogin():
	return "denrei"
def getPassword():
	return "asdfasdf"
def getGameType():
	return "Coda.CodaDemoGame"
def getCommandletUfile():
	return "CodaCommandLet.u"
def getCommandletName():
	return "CodaCommandLet"

def Listen():
	cmd = "\\UT3.exe "+map+"?game="+gameType+"?bIsLanMatch=True?quickstart=1?listen -mod=../Coda -login="+login+" -password="+password+" -windowposx=1000 -windowposy=75 -consoleposx=0 -consoleposy=75 -windowed -resx=1280 -resy=720 -useunpublished -log -nomoviestartup"
	print "Running..."
	pipe = Popen(UTBinariesPath+cmd)

def Join():
	cmd = "\\UT3.exe 127.0.0.1?spectatoronly=0?name=denreiClient -mod=../Coda -consoleheight=75 -windowposx=1000 -windowposy=600 -consoleposx=0 -consoleposy=600 -windowed -resx=640 -resy=480 -useunpublished -log -nomoviestartup"
	print "Running..."
	pipe = Popen(UTBinariesPath+cmd)

def Test():
	ClearUTCustomChar()
	cmd = "\\UT3.exe "+map+"?game="+gameType+"?spectatoronly=0?quickstart=1?numplay=1 -mod=../Coda -nomoviestartup -useunpublished -log"
#	cmd = "\\UT3.exe ?quickstart=1?numplay=1 -mod=../Coda -nomoviestartup -useunpublished -log -windowed -resx=640 -resy=480"	
	print "Running", cmd
	pipe = Popen(UTBinariesPath+cmd)
#"+map+"?game="+gameType+"
#?login=denrei?password=asdfasdf

def GetIp():
	stdout = Popen("ipconfig", shell=True, stdout=PIPE).communicate()[0]
	ip = stdout.partition("IP Address")[2]	
	ip = ip.strip(": .")
	ip = ip.partition("\n")[0]
	ip = ip.strip("\n ")
	return ip

def MakeUnpublished():
	cmd = "UT3.exe make -useunpublished"
	print "Running", cmd
	pipe = Popen(UTBinariesPath+cmd)
	pipe.wait()

def Dedicated():
	cmd = "\\UT3.exe Server "+map+"?game="+gameType+"?bIsLanMatch=True -login="+login+" -password="+password+" -useunpublished"
	print "Running", cmd
	pipe = Popen(UTBinariesPath+cmd)
"""
def RunPlayable():
	cmd = "UT3.exe "+map+"?game="+gameType+"?bIsLanMatch=True -login="+login+" -password="+password+" -useunpublished -log"
	print "Running", cmd
	pipe = Popen(UTBinariesPath+cmd)
"""

def Unpublished():
	ClearUTCustomChar()
	cmd = "\\UT3.exe -useunpublished -log"
	print "Running", cmd
	pipe = Popen(UTBinariesPath+cmd)

def SetPackageFlags():
#	cmd = "ut3.exe SetPackageFlags \""+ UTGamePath +"Unpublished/CookedPC/Coda/CH_Marek.upk\" ServerSideOnly=true"
#	cmd = "ut3.exe SetPackageFlags \""+ UTGamePath +"Unpublished/CookedPC/Coda/CH_Viv.upk\" ServerSideOnly=true"
	cmd = "\\ut3.exe SetPackageFlags \""+ UTGamePath +"Unpublished/CookedPC/Coda/CH_Gen.upk\" ServerSideOnly=true"
	print "Running", cmd
	pipe = Popen(UTBinariesPath+cmd)

def TeamGame():
#	cmd = "UT3.exe DM-Deck?name=denrei?team=255?game=UTGame.UTTeamGame?MaxPlayers=16?MinNetPlayers=0?NumPublicConnections=16?NumPrivateConnections=0?NumOpenPublicConnections=0?NumOpenPrivateConnections=0?bShouldAdvertise=True?bIsLanMatch=False?bUsesStats=True?bAllowJoinInProgress=True?bAllowInvites=True?bUsesPresence=True?bAllowJoinViaPresence=True?bUsesArbitration=False?bIsDedicated=False?bIsListPlay=False?OwningPlayerName=?PingInMs=0?AverageSkillRating=1000.000000?EngineVersion=0?MinNetVersion=0?GameMode=4?Difficulty=2?PureServer=1?LockedServer=0?Campaign=0?ForceRespawn=0?CustomMapName=?CustomGameMode=?GoalScore=50?TimeLimit=20?ServerDescription=?NumPlay=6?alias=denrei"
#	cmd = "UT3.exe DM-Gateway?name=Player?team=255?game=UTGame.UTTeamGame?MaxPlayers=16?MinNetPlayers=0?NumPublicConnections=16?NumPrivateConnections=0?NumOpenPublicConnections=0?NumOpenPrivateConnections=0?bShouldAdvertise=True?bIsLanMatch=False?bUsesStats=True?bAllowJoinInProgress=True?bAllowInvites=True?bUsesPresence=True?bAllowJoinViaPresence=True?bUsesArbitration=False?bIsDedicated=False?bIsListPlay=False?OwningPlayerName=?PingInMs=0?AverageSkillRating=1000.000000?EngineVersion=0?MinNetVersion=0?GameMode=4?Difficulty=2?PureServer=1?LockedServer=0?Campaign=0?ForceRespawn=0?CustomMapName=?CustomGameMode=?GoalScore=50?TimeLimit=20?ServerDescription=?NumPlay=6?mutator=CodaScriptPackage.UTMutator_Coda  -log -useunpublished"
	cmd = "\\UT3.exe vCTF-Suspense?name=Player?team=255?game=UTGameContent.UTVehicleCTFGame_Content?MaxPlayers=16?MinNetPlayers=0?NumPublicConnections=16?NumPrivateConnections=0?NumOpenPublicConnections=0?NumOpenPrivateConnections=0?bShouldAdvertise=True?bIsLanMatch=False?bUsesStats=True?bAllowJoinInProgress=True?bAllowInvites=True?bUsesPresence=True?bAllowJoinViaPresence=True?bUsesArbitration=False?bIsDedicated=False?bIsListPlay=False?OwningPlayerName=?PingInMs=0?AverageSkillRating=1000.000000?EngineVersion=0?MinNetVersion=0?GameMode=3?Difficulty=2?PureServer=1?LockedServer=0?Campaign=0?ForceRespawn=0?CustomMapName=?CustomGameMode=?GoalScore=3?TimeLimit=20?ServerDescription=?NumPlay=12?mutator=CodaScriptPackage.UTMutator_Coda -log -useunpublished"
	print "Running", cmd
	pipe = Popen(UTBinariesPath+cmd)
#-wxwindows 

def UnrealEd():
	ClearAutoSaves()
	cmd = "\\UT3.exe editor -mod=../Coda -useunpublished"
	print "Running..."
	pipe = Popen(UTBinariesPath+cmd)

# This function is because new Commandlets need to exist in the binaries folder... 
def RunCommandlet():
	commandletOrigin = UTGamePath + "Unpublished\\CookedPC\\Script\\" + commandletUfile
	commandletDest = UTBinariesPath + "CookedPC\\" + commandletUfile

	print "Copying "+commandletOrigin+" to "+commandletDest
	shutil.copy( commandletOrigin, commandletDest)

	cmd = UTBinariesPath+"UT3.exe run "+commandletUfile.replace(".u","")+"."+commandletName
	print "Running "+cmd+"..."
	pipe = Popen(cmd)
	pipe.wait()

	os.remove( commandletDest )

def ClearAutoSaves():
	autoSavePath = UTGamePath + '\Autosaves'
	if os.access( autoSavePath, os.F_OK ):
		shutil.rmtree( autoSavePath ) 

def ClearUTCustomChar():
	customCharPath = UTGamePath + '\Config\UTCustomChar.ini'
	if os.access( customCharPath, os.F_OK ):
		os.remove( customCharPath ) 


UTGamePath = getUTGamePath()
UTBinariesPath = getUTBinariesPath()

myIp = GetIp() # You can replace this with a static address if you need to
serverIp = "192.168.1.102"

map = getMap()
login = getLogin()
password = getPassword()
gameType = getGameType()
commandletUfile = getCommandletUfile()
commandletName = getCommandletName()
